/* icondm - Icon DE Display Manager
*/

#include "button.h"

using namespace std;

void imenu::init_button()
{
    int i;
    t_group=0;
    m_group_begin=-1;
    m_group_end=-1;
    show_lines=15;
    bc_red=Cfg::string2int(cfg->getOption("bc_red").c_str());
    bc_green=Cfg::string2int(cfg->getOption("bc_green").c_str());
    bc_blue=Cfg::string2int(cfg->getOption("bc_blue").c_str());
    bc_alpha=Cfg::string2int(cfg->getOption("bc_alpha").c_str());
	bf_red=Cfg::string2int(cfg->getOption("bf_red").c_str());
	bf_green=Cfg::string2int(cfg->getOption("bf_green").c_str());
	bf_blue=Cfg::string2int(cfg->getOption("bf_blue").c_str());
	bf_alpha=Cfg::string2int(cfg->getOption("bf_alpha").c_str());

    x=Cfg::string2int(cfg->getOption("icon_top").c_str());
    y=Cfg::string2int(cfg->getOption("icon_left").c_str());
    width1=Cfg::string2int(cfg->getOption("icon_width1").c_str());
    width2=Cfg::string2int(cfg->getOption("icon_width2").c_str());
    width3=Cfg::string2int(cfg->getOption("icon_width3").c_str());
    width4=Cfg::string2int(cfg->getOption("icon_width4").c_str());
    height=Cfg::string2int(cfg->getOption("icon_height").c_str());
    width_text=Cfg::string2int(cfg->getOption("text_width").c_str());
    w_gap=Cfg::string2int(cfg->getOption("wide_gap").c_str());
    h_gap=Cfg::string2int(cfg->getOption("high_gap").c_str());
    menu1.text[0]='\0';
    menu1.group=-1;
    menu1.tag_int=0;
    menu1.tag_text[0]='\0';
    menu1.selected=0;
    menu1.flash=1;
    menu1.hide=0;
    menu1.w_id=0;

    sprintf(b_up.text,"/\\");
    b_up.group=-1;
    b_up.tag_int=0;
    b_up.tag_text[0]='\0';
    b_up.selected=0;
    b_up.flash=0;
    b_up.hide=0;
    b_up.w_id=0;

    sprintf(b_down.text,"\\/");
    b_down.group=-1;
    b_down.tag_int=0;
    b_down.tag_text[0]='\0';
    b_down.selected=0;
    b_down.flash=0;
    b_down.hide=0;
    b_down.w_id=0;

    for (i=0;i<15;i++)
    {
        menu2[i].text[0]='\0';
        menu2[i].group=i;
        menu2[i].tag_int=0;
        menu2[i].tag_text[0]='\0';
        menu2[i].selected=0;
        menu2[i].flash=0;
        menu2[i].hide=1;
        menu2[i].w_id=0;
    }
    for (i=0;i<150;i++)
    {
        menu3[i].text[0]='\0';
        menu3[i].group=0;
        menu3[i].tag_int=0;
        menu3[i].tag_text[0]='\0';
        menu3[i].selected=0;
        menu3[i].flash=0;
        menu3[i].hide=1;
        menu3[i].w_id=0;
    }
    sprintf(menu4[0].text,"  确定  ");
    menu4[0].group=-1;
    menu4[0].tag_int=0;
    menu4[0].tag_text[0]='\0';
    menu4[0].selected=0;
    menu4[0].flash=0;
    menu4[0].hide=0;
    menu4[0].w_id=0;

    sprintf(menu4[1].text,"  取消  ");
    menu4[1].group=-1;
    menu4[1].tag_int=0;
    menu4[1].tag_text[0]='\0';
    menu4[1].selected=0;
    menu4[1].flash=0;
    menu4[1].hide=0;
    menu4[1].w_id=0;

    sprintf(menu4[2].text,"  其他  ");
    menu4[2].group=-1;
    menu4[2].tag_int=0;
    menu4[2].tag_text[0]='\0';
    menu4[2].selected=0;
    menu4[2].flash=0;
    menu4[2].hide=1;
    menu4[2].w_id=0;

    sprintf(input.text,"请在此录入。ESC清除；CTRL-V粘贴；BackSpace删除。");
    input.tag_text[0]='\0';
    input.hide=1;
    input.is_passwd=0;
    input.w_id=0;
    input.w_ip=0;
    input.cur=0;
    input.str_len=0;
    input.insert=1;
    button_vis = DefaultVisual(Dpy, DefaultScreen(Dpy));
    button_depth = DefaultDepth(Dpy, DefaultScreen(Dpy));
    button_cm = DefaultColormap(Dpy, DefaultScreen(Dpy));
                // text
}

int imenu::creat_button()
{
    Imlib_Image                 buffer3;
    Imlib_Image                 buffer;
    int    text_w, text_h;
    int i;

    bc_red=Cfg::string2int(cfg->getOption("bc_red").c_str());
    bc_green=Cfg::string2int(cfg->getOption("bc_green").c_str());
    bc_blue=Cfg::string2int(cfg->getOption("bc_blue").c_str());
    bc_alpha=Cfg::string2int(cfg->getOption("bc_alpha").c_str());
	bf_red=Cfg::string2int(cfg->getOption("bf_red").c_str());
	bf_green=Cfg::string2int(cfg->getOption("bf_green").c_str());
	bf_blue=Cfg::string2int(cfg->getOption("bf_blue").c_str());
	bf_alpha=Cfg::string2int(cfg->getOption("bf_alpha").c_str());

    x=Cfg::string2int(cfg->getOption("icon_top").c_str());
    y=Cfg::string2int(cfg->getOption("icon_left").c_str());
    width1=Cfg::string2int(cfg->getOption("icon_width1").c_str());
    width2=Cfg::string2int(cfg->getOption("icon_width2").c_str());
    width3=Cfg::string2int(cfg->getOption("icon_width3").c_str());
    width4=Cfg::string2int(cfg->getOption("icon_width4").c_str());
    height=Cfg::string2int(cfg->getOption("icon_height").c_str());
    width_text=Cfg::string2int(cfg->getOption("text_width").c_str());
    w_gap=Cfg::string2int(cfg->getOption("wide_gap").c_str());
    h_gap=Cfg::string2int(cfg->getOption("high_gap").c_str());
    range = imlib_create_color_range();
    font_size=Cfg::string2int(cfg->getOption("font_size").c_str());
    imlib_add_path_to_font_path("/usr/share/fonts/truetype/wqy/");
    imlib_add_path_to_font_path("/usr/share/fonts/wenquanyi/wqy-zenhei/");
    char font_name[128];
    sprintf(font_name,"wqy-zenhei.ttc/%d",font_size);
    font = imlib_load_font(font_name);
    font2 = imlib_load_font("wqy-zenhei.ttc/8");

    imlib_context_set_color_range(range);
    imlib_context_set_color(255, 255, 255, 255);
    imlib_add_color_to_color_range(0);
    /* add an orange color, semi-transparent 10 units from the first */
//    imlib_context_set_color(255, 200, 10, 255);
    imlib_context_set_color(bc_red, bc_green, bc_blue, bc_alpha);
    imlib_add_color_to_color_range(10);
    /* add black, fully transparent at the end 20 units away */
    imlib_context_set_color(70, 0, 0, 255);
    imlib_add_color_to_color_range(20);

     /**
        * Start rendering
        */

    imlib_context_set_display(Dpy);
    imlib_context_set_visual(button_vis);
    imlib_context_set_colormap(button_cm);
    imlib_context_set_dither(1);
    imlib_context_set_blend(0);
    imlib_context_set_color_modifier(NULL);

    imlib_context_set_font(font);
    
    if (b_up.hide!=1)
    {
        imlib_get_text_size(b_up.text, &text_w, &text_h);
        buffer3 = imlib_create_image(text_w+200, height+10);    
        b_up.w_id=XCreateSimpleWindow(Dpy, Root,x,y,text_w+10,height,0, 0,0);

        XSelectInput(Dpy, b_up.w_id,  ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
        XRaiseWindow(Dpy,b_up.w_id);
        XMapWindow(Dpy, b_up.w_id);

        imlib_get_text_size(b_up.text, &text_w, &text_h);
        imlib_context_set_drawable(b_up.w_id); 
        imlib_context_set_image(buffer3);
        imlib_image_fill_color_range_rectangle(0,0, text_w*4, text_h*2,-45.0);
        imlib_context_set_image(buffer3);
        imlib_context_set_drawable(b_up.w_id); 
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
        imlib_text_draw(5,(height-text_h)/2,b_up.text);
        /* set the buffer image as our current image */
        imlib_context_set_image(buffer3);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer3);
        imlib_free_image();
    }

    if (menu1.hide!=1)
    {
        buffer3 = imlib_create_image(width1+200, height+10);    
        imlib_get_text_size(menu1.text, &text_w, &text_h);
        if (b_up.hide!=1)
            menu1.w_id=XCreateSimpleWindow(Dpy, Root,x+text_w+10+w_gap,y,width1,height,0, 0,0);
        else
            menu1.w_id=XCreateSimpleWindow(Dpy, Root,x,y,width1,height,0, 0,0);
        XSelectInput(Dpy, menu1.w_id, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
        XRaiseWindow(Dpy,menu1.w_id);
        XMapWindow(Dpy, menu1.w_id);
        imlib_context_set_drawable(menu1.w_id); 
             /* draw the range */
        imlib_context_set_image(buffer3);
        imlib_image_fill_color_range_rectangle(0,0, width1*4, height*2,-45.0);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
        if (text_w>=width1) 
            imlib_text_draw(5,(height-text_h)/2,menu1.text);
        else
            imlib_text_draw((width1-text_w)/2,(height-text_h)/2,menu1.text);
        /* set the buffer image as our current image */
        imlib_context_set_image(buffer3);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer3);
        imlib_free_image();
    }
    
    int n,m,xx,o,text_cw,text_ch;
    char s_l[1024];
    if (t_group<0)
      t_group=0;
    if (t_group+show_lines>15)
      t_group=15-show_lines;
    o=0;
    buffer3 = imlib_create_image(width2+200, height+10);    
    buffer = imlib_create_image(width3+200, height+10);    
    for (i=t_group;i<t_group+show_lines;i++)
    {
        if (menu2[i].hide!=1)
        {
            menu2[i].w_id=XCreateSimpleWindow(Dpy, Root,x,y+(h_gap+height)*(o+1),width2,height,0, 0,0);
            XSelectInput(Dpy, menu2[i].w_id, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
            imlib_get_text_size(menu2[i].text, &text_w, &text_h);
            XRaiseWindow(Dpy,menu2[i].w_id);
            XMapWindow(Dpy, menu2[i].w_id);
            imlib_context_set_drawable(menu2[i].w_id); 
                 /* draw the range */
            imlib_context_set_image(buffer3);
            imlib_image_fill_color_range_rectangle(0,0, width2*4, height*2,-45.0);
            imlib_context_set_image(buffer3);
            imlib_context_set_drawable(menu2[i].w_id); 
            imlib_render_image_on_drawable(0, 0); 
            imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
            if (text_w>=width2) 
                imlib_text_draw(5,(height-text_h)/2,menu2[i].text);
            else
                imlib_text_draw((width2-text_w)/2,(height-text_h)/2,menu2[i].text);
            /* set the buffer image as our current image */
            imlib_context_set_image(buffer3);
            imlib_render_image_on_drawable(0, 0); 
            m=0;
            for (n=0;n<150;n++)
            {
                if ((menu3[n].hide!=1) and (menu3[n].group==menu2[i].group))
                {
                    menu3[n].w_id=XCreateSimpleWindow(Dpy, Root,x+width2+w_gap+(width3+w_gap)*(m),y+(h_gap+height)*(o+1),width3,height,0, 0,0);
                    XSelectInput(Dpy, menu3[n].w_id, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
                    imlib_get_text_size(menu3[n].text, &text_w, &text_h);
                    XRaiseWindow(Dpy,menu3[n].w_id);
                    XMapWindow(Dpy, menu3[n].w_id);
                    imlib_context_set_drawable(menu3[n].w_id); 
                         /* draw the range */
                    imlib_context_set_image(buffer);
                    imlib_image_fill_color_range_rectangle(0,0, width3*4, height*2,-45.0);
                    imlib_render_image_on_drawable(0, 0); 
                    imlib_context_set_font(font2);
                    imlib_get_text_size("√", &text_w, &text_h);
                    imlib_context_set_color(0, 0, 255, 255);
                    if (menu3[n].selected==1)
                        imlib_text_draw(1,(height-text_h)/2,"√");
                    /* set the buffer image as our current image */

                    imlib_render_image_on_drawable(0, 0); 
                    imlib_context_set_font(font);
                    imlib_get_text_size(menu3[n].text, &text_w, &text_h);
                    imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
                    if (text_w>=width3) 
                        imlib_text_draw(5,(height-text_h)/2,menu3[n].text);
                    else
                        imlib_text_draw((width3-text_w)/2,(height-text_h)/2,menu3[n].text);
                    /* set the buffer image as our current image */
                    imlib_context_set_image(buffer);
                    imlib_render_image_on_drawable(0, 0); 
                    m=m+1;
                }
            }
            o=o+1;
        }
    }
    imlib_context_set_image(buffer3);
    imlib_free_image();
    imlib_context_set_image(buffer);
    imlib_free_image();
    if (input.hide!=1)
    {
        buffer3 = imlib_create_image(width_text+200, height+10);    
        input.w_id=XCreateSimpleWindow(Dpy, Root,x,y+(h_gap+height)*(o+1),width_text,height,0, 0,0);
        input.w_ip=XCreateSimpleWindow(Dpy, Root,x,y+(h_gap+height)*(o+2),width_text,height,0, 0,0);

        XSelectInput(Dpy, input.w_id, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
        XRaiseWindow(Dpy,input.w_id);
        XMapWindow(Dpy, input.w_id);

        XSelectInput(Dpy, input.w_ip, ExposureMask | KeyPressMask | StructureNotifyMask);
        XRaiseWindow(Dpy,input.w_ip);
        XMapWindow(Dpy, input.w_ip);

        XSync(Dpy, False);
        XMoveResizeWindow(Dpy, input.w_ip, x,y+(h_gap+height)*(o+2),width_text,height);
        XFlush(Dpy);
        XSync(Dpy, False);
        imlib_context_set_font(font);
        imlib_get_text_size(input.text, &text_w, &text_h);
        imlib_context_set_drawable(input.w_id); 
             /* draw the range */
        imlib_context_set_image(buffer3);
        imlib_image_fill_color_range_rectangle(0,0,width_text+200,height+100,-45.0);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_font(font);
        imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
        if (text_w>=width_text) 
            imlib_text_draw(5,(height-text_h)/2,input.text);
        else
            imlib_text_draw((width_text-text_w)/2,(height-text_h)/2,input.text);
        imlib_context_set_image(buffer3);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer3);
        /* set the buffer image as our current image */
        imlib_context_set_font(font);
        imlib_get_text_size(input.tag_text, &text_w, &text_h);
        imlib_context_set_drawable(input.w_ip); 
             /* draw the range */
        imlib_context_set_image(buffer3);
        imlib_image_fill_color_range_rectangle(0,0,width_text+200, height+45,-45.0);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_font(font2);
        imlib_context_set_color(255, 0, 0, 255);
        if (text_w<width_text-20)
            xx=0;
        else
            xx=width_text-text_w-20;
        if (input.insert==0)
        {
            imlib_get_text_size("△", &text_cw, &text_ch);
            imlib_text_draw(xx+text_w+5-text_cw/2,height-(height-text_h)/2-5,"△");
        }
        else
        {
            imlib_get_text_size("▲", &text_cw, &text_ch);
            imlib_text_draw(xx+text_w+5-text_cw/2,height-(height-text_h)/2-5,"▲");
        }
        sprintf(s_l,"%s",input.tag_text);
//        printf("%s▲%s\n",s_l,s_r);
        imlib_context_set_font(font);
        if (input.is_passwd==0)
        {
            imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
            imlib_text_draw(xx+5,(height-text_h)/2,input.tag_text);
        }
        else
        {
            imlib_context_set_color(bf_red, bf_green, bf_blue, 10);
            imlib_text_draw(xx+5,(height-text_h)/2,input.tag_text);
        }
        /* set the buffer image as our current image */
        imlib_context_set_image(buffer3);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer3);
        imlib_free_image();
//        printf("%d,%s\n",input.str_len,input.tag_text);
        o=o+2;
        
    }

    if (b_down.hide!=1)
    {
        imlib_get_text_size(b_down.text, &text_w, &text_h);
        buffer3 = imlib_create_image(text_w+200, height+10);    
        b_down.w_id=XCreateSimpleWindow(Dpy, Root,x,y+(h_gap+height)*(o+1),text_w+10,height,0, 0,0);
        XSelectInput(Dpy, b_down.w_id, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
        XRaiseWindow(Dpy,b_down.w_id);
        XMapWindow(Dpy, b_down.w_id);
        imlib_context_set_drawable(b_down.w_id); 
             /* draw the range */
        imlib_context_set_image(buffer3);
        imlib_image_fill_color_range_rectangle(0,0, text_w*4, height*2,-45.0);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_font(font);
        imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
        imlib_text_draw(5,(height-text_h)/2,b_down.text);
        /* set the buffer image as our current image */
        imlib_context_set_image(buffer3);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer3);
        imlib_free_image();
    }
    int xl;
    if (b_down.hide!=1)
        xl=text_w+10+w_gap;
    else
        xl=0;
    if (menu4[0].hide!=1)
    {
        buffer3 = imlib_create_image(width4+200, height+10);    
        menu4[0].w_id=XCreateSimpleWindow(Dpy, Root,x+xl,y+(h_gap+height)*(o+1),width4,height,0, 0,0);
        xl=xl+width4+w_gap;
        XSelectInput(Dpy, menu4[0].w_id, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
        imlib_get_text_size(menu4[0].text, &text_w, &text_h);
        XRaiseWindow(Dpy,menu4[0].w_id);
        XMapWindow(Dpy, menu4[0].w_id);
        imlib_context_set_drawable(menu4[0].w_id); 
             /* draw the range */
        imlib_context_set_image(buffer3);
        imlib_image_fill_color_range_rectangle(0,0, width4*4, height*2,-45.0);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_font(font);
        imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
        if (text_w>=width4) 
            imlib_text_draw(5,(height-text_h)/2,menu4[0].text);
        else
            imlib_text_draw((width4-text_w)/2,(height-text_h)/2,menu4[0].text);
        /* set the buffer image as our current image */
        imlib_context_set_image(buffer3);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer3);
        imlib_free_image();
    }
    if (menu4[1].hide!=1)
    {
        buffer3 = imlib_create_image(width4+200, height+10);    
        menu4[1].w_id=XCreateSimpleWindow(Dpy, Root,x+xl,y+(h_gap+height)*(o+1),width4,height,0, 0,0);
        XSelectInput(Dpy, menu4[1].w_id, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
        xl=xl+width4+w_gap;
        XRaiseWindow(Dpy,menu4[1].w_id);
        XMapWindow(Dpy, menu4[1].w_id);
        imlib_context_set_drawable(menu4[1].w_id); 
             /* draw the range */
        imlib_context_set_image(buffer3);
        imlib_image_fill_color_range_rectangle(0,0, width4*4, height*2,-45.0);
        imlib_render_image_on_drawable(0, 0); 
        imlib_get_text_size(menu4[1].text, &text_w, &text_h);
        imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
        if (text_w>=width4) 
            imlib_text_draw(5,(height-text_h)/2,menu4[1].text);
        else
            imlib_text_draw((width4-text_w)/2,(height-text_h)/2,menu4[1].text);
        /* set the buffer image as our current image */
        imlib_context_set_image(buffer3);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer3);
        imlib_free_image();
    }
    if (menu4[2].hide!=1)
    {
        buffer3 = imlib_create_image(width4+200, height+10);    
        if (b_down.hide!=1)
            menu4[2].w_id=XCreateSimpleWindow(Dpy, Root,x+xl+(width4+w_gap)*2,y+(h_gap+height)*(o+1),width4,height,0, 0,0);
        else
            menu4[2].w_id=XCreateSimpleWindow(Dpy, Root,x+(width4+w_gap)*2,y+(h_gap+height)*(o+1),width4,height,0, 0,0);
        XSelectInput(Dpy, menu4[2].w_id, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
        XRaiseWindow(Dpy,menu4[2].w_id);
        XMapWindow(Dpy, menu4[2].w_id);
        imlib_context_set_drawable(menu4[2].w_id); 
             /* draw the range */
        imlib_context_set_image(buffer3);
        imlib_image_fill_color_range_rectangle(0,0, width4*4, height*2,-45.0);
        imlib_render_image_on_drawable(0, 0); 
        imlib_get_text_size(menu4[2].text, &text_w, &text_h);
        imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
        if (text_w>=width4) 
            imlib_text_draw(5,(height-text_h)/2,menu4[2].text);
        else
            imlib_text_draw((width4-text_w)/2,(height-text_h)/2,menu4[2].text);
        /* set the buffer image as our current image */
        imlib_context_set_image(buffer3);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer3);
        imlib_free_image();
    }
    if (input.hide!=1)
    {
        sleep (1);
        buffer3 = imlib_create_image(width_text+200, height+10);    
        imlib_get_text_size(input.tag_text, &text_w, &text_h);
        imlib_context_set_drawable(input.w_ip); 
             /* draw the range */
        imlib_context_set_image(buffer3);
        imlib_image_fill_color_range_rectangle(0,0,width_text+200, height+45,-45.0);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_font(font2);
        imlib_context_set_color(255, 0, 0, 255);
        if (text_w<width_text-20)
            x=0;
        else
            x=width_text-text_w-20;
        if (input.insert==0)
        {
            imlib_get_text_size("△", &text_cw, &text_ch);
            imlib_text_draw(x+text_w+5-text_cw/2,height-(height-text_h)/2-5,"△");
        }
        else
        {
            imlib_get_text_size("▲", &text_cw, &text_ch);
            imlib_text_draw(x+text_w+5-text_cw/2,height-(height-text_h)/2-5,"▲");
        }
        sprintf(s_l,"%s",input.tag_text);
//        printf("%s▲%s\n",s_l,s_r);
        imlib_context_set_font(font);
        imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
        if (input.is_passwd==0)
        {
            imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
            imlib_text_draw(x+5,(height-text_h)/2,input.tag_text);
        }
        else
        {
            imlib_context_set_color(bf_red, bf_green, bf_blue, 10);
            imlib_text_draw(x+5,(height-text_h)/2,input.tag_text);
        }
        /* set the buffer image as our current image */
        XSetInputFocus(Dpy, input.w_ip, RevertToParent, CurrentTime);
        imlib_context_set_image(buffer3);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer3);
        imlib_free_image();
//        printf("%d,%s\n",input.str_len,input.tag_text);
    }
    imlib_context_set_color_range(range);
    imlib_free_color_range();
    imlib_context_set_font(font);
    imlib_free_font();
    imlib_context_set_font(font2);
    imlib_free_font();
    return 0;
}

void imenu::destory_button()
{
    int i;
    t_group=0;
    m_group_begin=-1;
    m_group_end=-1;
    show_lines=15;
    x=100;
    y=60;
    width1=300;
    width2=80;
    width3=60;
    width4=100;
    height=25;
    w_gap=3;
    h_gap=15;
    menu1.text[0]='\0';
    menu1.group=-1;
    menu1.tag_int=0;
    menu1.tag_text[0]='\0';
    menu1.selected=0;
    menu1.flash=1;
    menu1.hide=1;
    if (menu1.w_id!=0)
    {
        XDestroyWindow(Dpy,menu1.w_id);
        menu1.w_id=0;
    }

    sprintf(b_up.text,"/\\");
    b_up.group=-1;
    b_up.tag_int=0;
    b_up.tag_text[0]='\0';
    b_up.selected=0;
    b_up.flash=0;
    b_up.hide=1;
    if (b_up.w_id!=0)
    {
        XDestroyWindow(Dpy,b_up.w_id);
        b_up.w_id=0;
    }

    sprintf(b_down.text,"\\/");
    b_down.group=-1;
    b_down.tag_int=0;
    b_down.tag_text[0]='\0';
    b_down.selected=0;
    b_down.flash=0;
    b_down.hide=1;
    if (b_down.w_id!=0)
    {
        XDestroyWindow(Dpy,b_down.w_id);
        b_down.w_id=0;
    }

    for (i=0;i<15;i++)
    {
        menu2[i].text[0]='\0';
        menu2[i].group=i;
        menu2[i].tag_int=0;
        menu2[i].tag_text[0]='\0';
        menu2[i].selected=0;
        menu2[i].flash=0;
        menu2[i].hide=1;
        if (menu2[i].w_id!=0)
        {
            XDestroyWindow(Dpy,menu2[i].w_id);
            menu2[i].w_id=0;
        }
    }
    for (i=0;i<150;i++)
    {
        menu3[i].text[0]='\0';
        menu3[i].group=0;
        menu3[i].tag_int=0;
        menu3[i].tag_text[0]='\0';
        menu3[i].selected=0;
        menu3[i].flash=0;
        menu3[i].hide=1;
        if (menu3[i].w_id!=0)
        {
            XDestroyWindow(Dpy,menu3[i].w_id);
            menu3[i].w_id=0;
        }
    }
    sprintf(menu4[0].text,"  确定  ");
    menu4[0].group=-1;
    menu4[0].tag_int=0;
    menu4[0].tag_text[0]='\0';
    menu4[0].selected=0;
    menu4[0].flash=0;
    menu4[0].hide=1;
    if (menu4[0].w_id!=0)
    {
        XDestroyWindow(Dpy,menu4[0].w_id);
        menu4[0].w_id=0;
    }

    sprintf(menu4[1].text,"  取消  ");
    menu4[1].group=-1;
    menu4[1].tag_int=0;
    menu4[1].tag_text[0]='\0';
    menu4[1].selected=0;
    menu4[1].flash=0;
    menu4[1].hide=1;
    if (menu4[1].w_id!=0)
    {
        XDestroyWindow(Dpy,menu4[1].w_id);
        menu4[1].w_id=0;
    }

    sprintf(menu4[2].text,"  其他  ");
    menu4[2].group=-1;
    menu4[2].tag_int=0;
    menu4[2].tag_text[0]='\0';
    menu4[2].selected=0;
    menu4[2].flash=0;
    menu4[2].hide=1;
    if (menu4[2].w_id!=0)
    {
        XDestroyWindow(Dpy,menu4[2].w_id);
        menu4[2].w_id=0;
    }
    if (input.w_id!=0)
    {
        XDestroyWindow(Dpy,input.w_id);
        input.w_id=0;
    }
    if (input.w_ip!=0)
    {
        XDestroyWindow(Dpy,input.w_ip);
        input.w_ip=0;
    }
    sprintf(input.text,"请在此录入。（支持：ESC清除；CTRL-V粘贴）");
    input.tag_text[0]='\0';
    input.hide=1;
    input.is_passwd=0;
    input.w_id=0;
    input.w_ip=0;
    input.str_len=0;
    input.insert=1;
    input.cur=0;
}

void imenu::hide_button()
{
    int i;
    if (menu1.w_id!=0)
    {
        XDestroyWindow(Dpy,menu1.w_id);
        menu1.w_id=0;
    }
    if (b_up.w_id!=0)
    {
        XDestroyWindow(Dpy,b_up.w_id);
        b_up.w_id=0;
    }

    if (b_down.w_id!=0)
    {
        XDestroyWindow(Dpy,b_down.w_id);
        b_down.w_id=0;
    }

    for (i=0;i<15;i++)
    {
        if (menu2[i].w_id!=0)
        {
            XDestroyWindow(Dpy,menu2[i].w_id);
            menu2[i].w_id=0;
        }
    }
    for (i=0;i<150;i++)
    {
        if (menu3[i].w_id!=0)
        {
            XDestroyWindow(Dpy,menu3[i].w_id);
            menu3[i].w_id=0;
        }
    }

    if (input.w_id!=0)
    {
        XDestroyWindow(Dpy,input.w_id);
        input.w_id=0;
    }

    if (input.w_ip!=0)
    {
        XDestroyWindow(Dpy,input.w_ip);
        input.w_ip=0;
    }

    if (menu4[0].w_id!=0)
    {
        XDestroyWindow(Dpy,menu4[0].w_id);
        menu4[0].w_id=0;
    }

    if (menu4[1].w_id!=0)
    {
        XDestroyWindow(Dpy,menu4[1].w_id);
        menu4[1].w_id=0;
    }

    if (menu4[2].w_id!=0)
    {
        XDestroyWindow(Dpy,menu4[2].w_id);
        menu4[2].w_id=0;
    }
}


void imenu::filter_button(int mode)
{
    int i,m,n,o,text_w,text_h;
    Imlib_Image                 buffer3;
    Imlib_Image                 buffer;

                // text
    imlib_context_set_display(Dpy);
    imlib_context_set_visual(button_vis);
    imlib_context_set_colormap(button_cm);
    imlib_context_set_dither(1);
    imlib_context_set_blend(0);
    imlib_context_set_color_modifier(NULL);

    range = imlib_create_color_range();
    imlib_context_set_color_range(range);
    imlib_context_set_color(255, 255, 255, 255);
    imlib_add_color_to_color_range(0);
    /* add an orange color, semi-transparent 10 units from the first */
//    imlib_context_set_color(255, 200, 10, 255);
    imlib_context_set_color(bc_red, bc_green, bc_blue, bc_alpha);
    imlib_add_color_to_color_range(10);
    /* add black, fully transparent at the end 20 units away */
    imlib_context_set_color(70, 0, 0, 255);
    imlib_add_color_to_color_range(20);
   
    if (mode==0)
    {
        font_size=Cfg::string2int(cfg->getOption("font_size").c_str());
        imlib_add_path_to_font_path("/usr/share/fonts/truetype/wqy/");
        imlib_add_path_to_font_path("/usr/share/fonts/wenquanyi/wqy-zenhei/");
        char font_name[128];
        sprintf(font_name,"wqy-zenhei.ttc/%d",font_size);
        font = imlib_load_font(font_name);
        font2 = imlib_load_font("wqy-zenhei.ttc/8");
        buffer3 = imlib_create_image(width3+200, height+10);    
        for (n=0;n<150;n++)
        {
            if (menu3[n].w_id!=0)
            {
                imlib_context_set_drawable(menu3[n].w_id); 
                     /* draw the range */
                imlib_context_set_image(buffer3);
                imlib_image_fill_color_range_rectangle(0,0, width3*4, height*2,-45.0);
                imlib_render_image_on_drawable(0, 0); 
                imlib_context_set_font(font2);
                imlib_get_text_size("√", &text_w, &text_h);
                imlib_context_set_color(0, 0, 255, 255);
                if (menu3[n].selected==1)
                    imlib_text_draw(1,(height-text_h)/2,"√");
                imlib_render_image_on_drawable(0, 0); 
                imlib_context_set_font(font);
                imlib_get_text_size(menu3[n].text, &text_w, &text_h);
                imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
                if (text_w>=width3) 
                    imlib_text_draw(5,(height-text_h)/2,menu3[n].text);
                else
                    imlib_text_draw((width3-text_w)/2,(height-text_h)/2,menu3[n].text);
                /* set the buffer image as our current image */
                imlib_context_set_image(buffer3);
                imlib_render_image_on_drawable(0, 0); 
            }
        }
        if (input.hide!=1)
            XSetInputFocus(Dpy, input.w_ip, RevertToParent, CurrentTime);
        imlib_context_set_image(buffer3);
        imlib_free_image();
        imlib_context_set_font(font);
        imlib_free_font();
        imlib_context_set_font(font2);
        imlib_free_font();
    }
    else if (mode==1)
    {
        font_size=Cfg::string2int(cfg->getOption("font_size").c_str());
        imlib_add_path_to_font_path("/usr/share/fonts/truetype/wqy/");
        imlib_add_path_to_font_path("/usr/share/fonts/wenquanyi/wqy-zenhei/");
        char font_name[128];
        sprintf(font_name,"wqy-zenhei.ttc/%d",font_size);
        font = imlib_load_font(font_name);
        font2 = imlib_load_font("wqy-zenhei.ttc/8");
        for (i=0;i<15;i++)
        {
            if (menu2[i].w_id!=0)
            {
                XDestroyWindow(Dpy,menu2[i].w_id);
                menu2[i].w_id=0;
            }
        }
        for (i=0;i<150;i++)
        {
            if (menu3[i].w_id!=0)
            {
                XDestroyWindow(Dpy,menu3[i].w_id);
                menu3[i].w_id=0;
            }
        }
        o=0;
        buffer3 = imlib_create_image(width2+200, height+10);    
        buffer = imlib_create_image(width3+200, height+10);    
        for (i=t_group;i<t_group+show_lines;i++)
        {
            if (menu2[i].hide!=1)
            {
                menu2[i].w_id=XCreateSimpleWindow(Dpy, Root,x,y+(h_gap+height)*(o+1),width2,height,0, 0,0);
                XSelectInput(Dpy, menu2[i].w_id, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
                imlib_get_text_size(menu2[i].text, &text_w, &text_h);
                XRaiseWindow(Dpy,menu2[i].w_id);
                XMapWindow(Dpy, menu2[i].w_id);
                imlib_context_set_drawable(menu2[i].w_id); 
                     /* draw the range */
                imlib_context_set_image(buffer3);
                imlib_image_fill_color_range_rectangle(0,0, width2*4, height*2,-45.0);
                imlib_context_set_image(buffer3);
                imlib_context_set_drawable(menu2[i].w_id); 
                imlib_render_image_on_drawable(0, 0); 
                imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
                if (text_w>=width2) 
                    imlib_text_draw(5,(height-text_h)/2,menu2[i].text);
                else
                    imlib_text_draw((width2-text_w)/2,(height-text_h)/2,menu2[i].text);
                /* set the buffer image as our current image */
                imlib_context_set_image(buffer3);
                imlib_render_image_on_drawable(0, 0); 
                m=0;
                for (n=0;n<150;n++)
                {
                    if ((menu3[n].hide!=1) and (menu3[n].group==menu2[i].group))
                    {
                        menu3[n].w_id=XCreateSimpleWindow(Dpy, Root,x+width2+w_gap+(width3+w_gap)*(m),y+(h_gap+height)*(o+1),width3,height,0, 0,0);
                        XSelectInput(Dpy, menu3[n].w_id, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
                        XRaiseWindow(Dpy,menu3[n].w_id);
                        XMapWindow(Dpy, menu3[n].w_id);
                        imlib_context_set_drawable(menu3[n].w_id); 
                             /* draw the range */
                        imlib_context_set_image(buffer);
                        imlib_image_fill_color_range_rectangle(0,0, width3*4, height*2,-45.0);
                        imlib_render_image_on_drawable(0, 0); 
                        imlib_context_set_font(font2);
                        imlib_get_text_size("√", &text_w, &text_h);
                        imlib_context_set_color(0, 0, 255, 255);
                        if (menu3[n].selected==1)
                            imlib_text_draw(1,(height-text_h)/2,"√");
                        imlib_render_image_on_drawable(0, 0); 
                        imlib_context_set_font(font);
                        imlib_get_text_size(menu3[n].text, &text_w, &text_h);
                        imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
                        if (text_w>=width3) 
                            imlib_text_draw(5,(height-text_h)/2,menu3[n].text);
                        else
                            imlib_text_draw((width3-text_w)/2,(height-text_h)/2,menu3[n].text);
                        /* set the buffer image as our current image */
                        imlib_context_set_image(buffer);
                        imlib_render_image_on_drawable(0, 0); 
                        m=m+1;
                    }
                }
                o=o+1;
            }
        }
        if (input.hide!=1)
            XSetInputFocus(Dpy, input.w_ip, RevertToParent, CurrentTime);
        imlib_context_set_image(buffer3);
        imlib_free_image();
        imlib_context_set_image(buffer);
        imlib_free_image();
        imlib_context_set_font(font);
        imlib_free_font();
        imlib_context_set_font(font2);
        imlib_free_font();
    }
    else if (mode==2)
    {
        hide_button();
        creat_button();
    }
    imlib_context_set_color_range(range);
    imlib_free_color_range();
}

int imenu::click_button(Window w_id)
{
    int i,n,i_return;

    i_return=-2;
    for (i=0;i<150;i++)
    {
        if (menu3[i].w_id==w_id)
        {
            if ((m_group_begin<0) or (menu3[i].group<m_group_begin) or (menu3[i].group>m_group_end))
            {
                for (n=0;n<150;n++)
                {
                    if (menu3[n].group==menu3[i].group)
                        menu3[n].selected=0;
                }
            }
            else
            {
                for (n=0;n<150;n++)
                {
                    if ((menu3[n].group>=m_group_begin) and (menu3[n].group<=m_group_end))
                        menu3[n].selected=0;
                }
            }
            menu3[i].selected=1;
            i_return=3;
            break;
        }
    }
    
    if (b_up.w_id==w_id)
    {
        if (t_group<=show_lines)
            t_group=0;
        else
            t_group=t_group-show_lines;
        i_return=4;
    }
    else if (b_down.w_id==w_id)
    {
        if (t_group+show_lines>=15)
            t_group=15-show_lines;
        else
            t_group=t_group+show_lines;
        i_return=4;
    }
    else if (menu4[0].w_id==w_id)
    {
        hide_button();
        i_return=0;
    }
    else if (menu4[1].w_id==w_id)
    {
        destory_button();
        i_return=1;
    }
    else if (menu4[2].w_id==w_id)
    {
        destory_button();
        i_return=2;
    }
    if (i_return==3)
        filter_button(0);
    if (i_return==4)
        filter_button(1);
    return i_return;

}

int imenu::input_text(XEvent &event)
{
    Imlib_Image                 buffer3;
    int i,text_w,text_h;
    int n,m,x,y;
    Bool redraw = False;
    int text_cw, text_ch;
    char s_l[1024],s_r[1024],buffer[1024];

    imlib_context_set_display(Dpy);
    imlib_context_set_visual(button_vis);
    imlib_context_set_colormap(button_cm);
    imlib_context_set_dither(1);
    imlib_context_set_blend(0);
    imlib_context_set_color_modifier(NULL);

    char ascii;
    KeySym keysym;
    XComposeStatus compstatus;
    string text;
    string formerString = "";
    XLookupString(&event.xkey, &ascii, 1, &keysym, &compstatus);
    redraw = False;
    if (keysym == XK_Delete) {
        if (input.cur<=input.str_len)
        {
            if ((unsigned char)input.tag_text[input.cur] < 0x80)
            {
                if (input.str_len > 0)
                {
                    for (i=input.cur;i<input.str_len;i++)
                        input.tag_text[i]=input.tag_text[i+1];
                    input.str_len--;
                    redraw = True;
                }
            }
            else
            {
                m=0;
                if ((input.str_len > 0) and ((unsigned char)input.tag_text[input.cur] >= 0xC0))
                {
                    redraw = True;
                    for (n=input.cur+1;n<input.str_len;n++)
                    {
                        m++;
                        if (((unsigned char)input.tag_text[n] >= 0xC0) or ((unsigned char)input.tag_text[n] < 0x80) )
                            break;
                        else if (((unsigned char)input.tag_text[n] >= 0x80) and ((unsigned char)input.tag_text[n] < 0xC0))
                            continue;
                    }
                    input.str_len=input.str_len-m;
                }
                for (i=input.cur;i<input.str_len;i++)
                    input.tag_text[i]=input.tag_text[i+m];
            }
            input.tag_text[input.str_len]='\0';
            redraw = True;
        }
    }
    else if (keysym == XK_BackSpace) {
        if (input.cur > 0)
        {
            if (input.cur>input.str_len) input.cur=input.str_len;
            if ((unsigned char)input.tag_text[input.cur-1] < 0x80)
            {
                if (input.cur > 0)
                {
                    for (i=input.cur;i<input.str_len;i++)
                        input.tag_text[i-1]=input.tag_text[i];
                    input.str_len--;
                    input.cur--;
                    redraw = True;
                }
            }
            else
            {
                m=0;
                if ((input.str_len > 0) and ((unsigned char)input.tag_text[input.cur-1] >= 0x80) and ((unsigned char)input.tag_text[input.cur-1] < 0xC0))
                {
                    input.str_len--;
                    input.cur--;
                    m++;
                }
                if ((input.str_len > 0) and ((unsigned char)input.tag_text[input.cur-1] >= 0x80) and ((unsigned char)input.tag_text[input.cur-1] < 0xC0))
                {
                    input.str_len--;
                    input.cur--;
                    m++;
                }
                if ((input.str_len > 0) and ((unsigned char)input.tag_text[input.cur-1] >= 0x80) and ((unsigned char)input.tag_text[input.cur-1] < 0xC0))
                {
                    input.str_len--;
                    input.cur--;
                    m++;
                }
                if ((input.str_len > 0) and ((unsigned char)input.tag_text[input.cur-1] >= 0x80) and ((unsigned char)input.tag_text[input.cur-1] < 0xC0))
                {
                    input.str_len--;
                    input.cur--;
                    m++;
                }
                if ((input.str_len > 0) and ((unsigned char)input.tag_text[input.cur-1] >= 0x80) and ((unsigned char)input.tag_text[input.cur-1] < 0xC0))
                {
                    input.str_len--;
                    input.cur--;
                    m++;
                }
                if ((input.str_len > 0) and ((unsigned char)input.tag_text[input.cur-1] >= 0xC0))
                {
                    input.str_len--;
                    input.cur--;
                    m++;
                }
                redraw = True;
                for (i=input.cur;i<input.str_len;i++)
                    input.tag_text[i]=input.tag_text[i+m];
            }
            input.tag_text[input.str_len]='\0';
        }
    }
    else if (keysym == XK_Escape)
    {
        input.tag_text[0]='\0';
        input.str_len=0;
        redraw=True;
    }
    else if (keysym == XK_Left)
    {
        if (input.cur<=0)
            input.cur=0;
        else
        {
            if (input.tag_text[input.cur-1] == '\0')
                input.cur=input.cur-1;
            else if ((unsigned char)input.tag_text[input.cur-1] < 0x80)
                input.cur=input.cur-1;
            else
            {
                if ((input.cur > 0) and ((unsigned char)input.tag_text[input.cur-1] >= 0x80) and ((unsigned char)input.tag_text[input.cur-1] < 0xC0))
                    input.cur--;
                if ((input.cur > 0) and ((unsigned char)input.tag_text[input.cur-1] >= 0x80) and ((unsigned char)input.tag_text[input.cur-1] < 0xC0))
                    input.cur--;
                if ((input.cur > 0) and ((unsigned char)input.tag_text[input.cur-1] >= 0x80) and ((unsigned char)input.tag_text[input.cur-1] < 0xC0))
                    input.cur--;
                if ((input.cur > 0) and ((unsigned char)input.tag_text[input.cur-1] >= 0x80) and ((unsigned char)input.tag_text[input.cur-1] < 0xC0))
                    input.cur--;
                if ((input.cur > 0) and ((unsigned char)input.tag_text[input.cur-1] >= 0x80) and ((unsigned char)input.tag_text[input.cur-1] < 0xC0))
                    input.cur--;
                if ((input.cur > 0) and ((unsigned char)input.tag_text[input.cur-1] >= 0xC0))
                    input.cur--;
            }
        }
        redraw=True;
    }
    else if (keysym == XK_Right)
    {
        if (input.cur>=input.str_len)
            input.cur=input.str_len+1;
        else
        {
            for (i=input.cur;i<=input.str_len;i++)
            {
                if ((unsigned char)input.tag_text[i] < 0x80)
                {
                    input.cur=input.cur+1;
                    break;
                }
                else if ((unsigned char)input.tag_text[i] >= 0xC0)
                {
                    input.cur=input.cur+1;
                    continue;
                }
                else
                {
                    for (n=input.cur;n<=input.str_len;n++)
                    {
                        if (((unsigned char)input.tag_text[n] >= 0x80) and ((unsigned char)input.tag_text[n] < 0xC0))
                            input.cur=input.cur+1;
                        if (((unsigned char)input.tag_text[n] >= 0xC0) or ((unsigned char)input.tag_text[n] < 0x80))
                        {
                            break;
                        }
                    }
                    break;
                }
            }
        }
        redraw=True;
    }
    else if (keysym == XK_End)
    {
        input.cur=input.str_len+1;
        redraw=True;
    }
    else if (keysym == XK_Home)
    {
        input.cur=0;
        redraw=True;
    }
    else if (keysym == XK_Insert)
    {
        if (input.insert==0)
            input.insert=1;
        else
            input.insert=0;
        redraw=True;
    }
    else
    {
//            printf("buffer:%s\n",buffer);
        m=0;
        sprintf(buffer,"%s",XKeysymToString(keysym));
        if (buffer[1]!='\0')
        {
            if (strcmp(buffer,"space")==0) sprintf(buffer," ");
            else if (strcmp(buffer,"exclam")==0) sprintf(buffer,"!");
            else if (strcmp(buffer,"quotedbl")==0) sprintf(buffer,"\"");
            else if (strcmp(buffer,"numbersign")==0) sprintf(buffer,"#");
            else if (strcmp(buffer,"dollar")==0) sprintf(buffer,"$");
            else if (strcmp(buffer,"percent")==0) sprintf(buffer,"%%");
            else if (strcmp(buffer,"ampersand")==0) sprintf(buffer,"&");
            else if (strcmp(buffer,"apostrophe")==0) sprintf(buffer,"\'");
            else if (strcmp(buffer,"parenleft")==0) sprintf(buffer,"(");
            else if (strcmp(buffer,"parenright")==0) sprintf(buffer,")");
            else if (strcmp(buffer,"asterisk")==0) sprintf(buffer,"*");
            else if (strcmp(buffer,"plus")==0) sprintf(buffer,"+");
            else if (strcmp(buffer,"comma")==0) sprintf(buffer,",");
            else if (strcmp(buffer,"minus")==0) sprintf(buffer,"-");
            else if (strcmp(buffer,"period")==0) sprintf(buffer,".");
            else if (strcmp(buffer,"slash")==0) sprintf(buffer,"/");
            else if (strcmp(buffer,"colon")==0) sprintf(buffer,":");
            else if (strcmp(buffer,"semicolon")==0) sprintf(buffer,";");
            else if (strcmp(buffer,"less")==0) sprintf(buffer,"<");
            else if (strcmp(buffer,"equal")==0) sprintf(buffer,"=");
            else if (strcmp(buffer,"greater")==0) sprintf(buffer,">");
            else if (strcmp(buffer,"question")==0) sprintf(buffer,"?");
            else if (strcmp(buffer,"at")==0) sprintf(buffer,"@");
            else if (strcmp(buffer,"bracketleft")==0) sprintf(buffer,"[");
            else if (strcmp(buffer,"backslash")==0) sprintf(buffer,"\\");
            else if (strcmp(buffer,"bracketright")==0) sprintf(buffer,"]");
            else if (strcmp(buffer,"asciicircum")==0) sprintf(buffer,"^");
            else if (strcmp(buffer,"underscore")==0) sprintf(buffer,"_");
            else if (strcmp(buffer,"grave")==0) sprintf(buffer,"`");
            else if (strcmp(buffer,"braceleft")==0) sprintf(buffer,"{");
            else if (strcmp(buffer,"bar")==0) sprintf(buffer,"|");
            else if (strcmp(buffer,"braceright")==0) sprintf(buffer,"}");
            else if (strcmp(buffer,"asciitilde")==0) sprintf(buffer,"~");   
            else if (strcmp(buffer,"KP_Divide")==0) sprintf(buffer,"/");
            else if (strcmp(buffer,"KP_Multiply")==0) sprintf(buffer,"*");
            else if (strcmp(buffer,"KP_Subtract")==0) sprintf(buffer,"-");
            else if (strcmp(buffer,"KP_Add")==0) sprintf(buffer,"+");
            else if (strcmp(buffer,"KP_9")==0) sprintf(buffer,"9");
            else if (strcmp(buffer,"KP_8")==0) sprintf(buffer,"8");
            else if (strcmp(buffer,"KP_7")==0) sprintf(buffer,"7");
            else if (strcmp(buffer,"KP_4")==0) sprintf(buffer,"4");
            else if (strcmp(buffer,"KP_5")==0) sprintf(buffer,"5");
            else if (strcmp(buffer,"KP_6")==0) sprintf(buffer,"6");
            else if (strcmp(buffer,"KP_3")==0) sprintf(buffer,"3");
            else if (strcmp(buffer,"KP_2")==0) sprintf(buffer,"2");
            else if (strcmp(buffer,"KP_1")==0) sprintf(buffer,"1");
            else if (strcmp(buffer,"KP_0")==0) sprintf(buffer,"0");
            else if (strcmp(buffer,"KP_Decimal")==0) sprintf(buffer,".");
            else
            {
                if (buffer[1]!='\0')
                {
                    buffer[0]='\0';
                }
            }
        }
        
        if (input.cur>=input.str_len)
        {
            sprintf(s_l,"%s",input.tag_text);
            s_r[0]='\0';
        }
        else
        {
            for (i=0;i<input.str_len;i++)
            {
                s_l[i]=input.tag_text[i];
                n=i;
                if (n>=input.cur)
                    break;
            }
            s_l[n]='\0';
            if (input.insert==1)
            {
                m=0;
                for (i=n;i<=input.str_len;i++)
                {
                    s_r[m]=input.tag_text[i];
                    m=m+1;
                }
                s_r[m]='\0';
            }
            else
            {
                x=1;
                y=0;
                m=0;
                for (i=input.cur;i<input.str_len;i++)
                {
                    if (((unsigned char)input.tag_text[i] < 0x80) or ((unsigned char)input.tag_text[i] >= 0xC0))
                    {
                        x=x-1;
                        y=y+1;
                    }
                    if ((x>=0) and ((unsigned char)input.tag_text[i] >= 0xC0))
                    {
                        for (m=i+1;m<input.str_len;m++) 
                        {
                            if (((unsigned char)input.tag_text[m] >= 0x80) and ((unsigned char)input.tag_text[m] < 0xC0))
                                y=y+1;
                            else
                                break;
                        }
                    }
                    if (x<=0)
                        break;
                }
                x=0;
                for (n=input.cur+y;n<input.str_len;n++)
                {
                    s_r[x]=input.tag_text[n];
                    x=x+1;
                }
                s_r[x]='\0';
            }
        }
//        printf("%s %s %s\n",s_l,st,s_r);
        sprintf(input.tag_text,"%s%s%s",s_l,buffer,s_r);
        if ((input.cur>=input.str_len) or (input.insert==1))
            input.str_len=input.str_len+1;
        else
            input.str_len=input.str_len+1-y;
        input.cur=input.cur+1;
        input.tag_text[input.str_len]='\0'; 
        redraw = True;
    }
    /* do a very simple-minded redraw, if needed */

    if (redraw) {
//        printf("redraw\n");
        range = imlib_create_color_range();
        imlib_context_set_color_range(range);
        imlib_context_set_color(255, 255, 255, 255);
        imlib_add_color_to_color_range(0);
        /* add an orange color, semi-transparent 10 units from the first */
    //    imlib_context_set_color(255, 200, 10, 255);
        imlib_context_set_color(bc_red, bc_green, bc_blue, bc_alpha);
        imlib_add_color_to_color_range(10);
        /* add black, fully transparent at the end 20 units away */
        imlib_context_set_color(70, 0, 0, 255);
        imlib_add_color_to_color_range(20);

        font_size=Cfg::string2int(cfg->getOption("font_size").c_str());
        imlib_add_path_to_font_path("/usr/share/fonts/truetype/wqy/");
        imlib_add_path_to_font_path("/usr/share/fonts/wenquanyi/wqy-zenhei/");
        char font_name[128];
        sprintf(font_name,"wqy-zenhei.ttc/%d",font_size);
        font = imlib_load_font(font_name);
        font2 = imlib_load_font("wqy-zenhei.ttc/8");
        imlib_context_set_font(font);
        imlib_get_text_size(input.tag_text, &text_w, &text_h);
        imlib_context_set_drawable(input.w_ip); 
             /* draw the range */
        buffer3 = imlib_create_image(width_text+200, height+10);    
        imlib_context_set_image(buffer3);
        imlib_image_fill_color_range_rectangle(0,0,width_text+200, height+45,-45.0);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_font(font2);
        imlib_context_set_color(255, 0, 0, 255);
        if (input.cur>=input.str_len)
        {
            if (text_w<width_text-20)
                x=0;
            else
                x=width_text-text_w-20;
            if (input.insert==0)
            {
                imlib_get_text_size("△", &text_cw, &text_ch);
                imlib_text_draw(x+text_w+5-text_cw/2,height-(height-text_h)/2-5,"△");
            }
            else
            {
                imlib_get_text_size("▲", &text_cw, &text_ch);
                imlib_text_draw(x+text_w+5-text_cw/2,height-(height-text_h)/2-5,"▲");
            }
            sprintf(s_l,"%s",input.tag_text);
            s_r[0]='\0';
        }
        else
        {
            for (i=0;i<input.str_len;i++)
            {
                s_l[i]=input.tag_text[i];
                n=i;
                if (n>=input.cur)
                    break;
            }
            s_l[n]='\0';
            imlib_context_set_font(font);
            imlib_get_text_size(s_l, &text_w, &text_h);
            if (text_w<width_text-20)
                x=0;
            else
                x=width_text-text_w-20;
            imlib_context_set_font(font2);
            imlib_context_set_color(255, 0, 0, 255);
            if (input.insert==0)
            {
                imlib_get_text_size("△", &text_cw, &text_ch);
                imlib_text_draw(x+text_w+5-text_cw/2,height-(height-text_h)/2-5,"△");
            }
            else
            {
                imlib_get_text_size("▲", &text_cw, &text_ch);
                imlib_text_draw(x+text_w+5-text_cw/2,height-(height-text_h)/2-5,"▲");
            }
            int m=0;
            for (i=n;i<=input.str_len;i++)
            {
                s_r[m]=input.tag_text[i];
                m=m+1;
            }
            s_r[m]='\0';
        }
//        printf("%s▲%s\n",s_l,s_r);
        imlib_context_set_font(font);
        imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
        if (input.is_passwd==0)
        {
            imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
            imlib_text_draw(x+5,(height-text_h)/2,input.tag_text);
        }
        else
        {
            imlib_context_set_color(bf_red, bf_green, bf_blue, 10);
            imlib_text_draw(x+5,(height-text_h)/2,input.tag_text);
        }
        /* set the buffer image as our current image */
        imlib_context_set_image(buffer3);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_color_range(range);
        imlib_free_color_range();
        imlib_context_set_font(font);
        imlib_free_font();
        imlib_context_set_font(font2);
        imlib_free_font();
        imlib_context_set_image(buffer3);
        imlib_free_image();
    }
    return 0;
}



imenu::imenu(Display* dpy, int scr, Window root, Cfg* config) {
    // Set display
    Dpy = dpy;
    Scr = scr;
    Root = root;
    cfg = config;

    Visual* visual = DefaultVisual(Dpy, Scr);
    Colormap colormap = DefaultColormap(Dpy, Scr);
    // NOTE: using XftColorAllocValue() would be a better solution. Lazy me.
    XftColorAllocName(Dpy, visual, colormap, cfg->getOption("msg_color").c_str(), &msgcolor);
    XftColorAllocName(Dpy, visual, colormap, cfg->getOption("msg_shadow_color").c_str(), &msgshadowcolor);
    msgfont = XftFontOpenName(Dpy, Scr, cfg->getOption("msg_font").c_str());;

    int i,n;
    init_button();
    t_group=0;
    b_up.hide=1;
    b_down.hide=1;
    m_group_begin=0;
    m_group_end=9;
    menu1.flash=1;
    menu1.group=-1;
    menu1.hide=0;
    menu1.selected=0;
    menu4[0].hide=0;
    menu4[1].hide=0;
    menu4[2].hide=0;
    sprintf(menu4[0].text,"登录");
    sprintf(menu4[1].text,"关机");
    sprintf(menu4[2].text,"重启");
    sprintf(menu1.text,"请分别选择以下选项，然后按“确认”。");
    
    sprintf(input.text,"请在此录入密码。");
    input.is_passwd=1;
    input.tag_text[0]='\0';
    input.hide=0;
    input.w_id=0;
    input.str_len=0;

    menu2[0].flash=0;
    menu2[0].group=0;
    menu2[0].hide=0;
    menu2[0].selected=0;
    sprintf(menu2[0].text,"各种 DE 环境：");
    
    menu3[0].flash=0;
    menu3[0].group=0;
    menu3[0].hide=0;
    menu3[0].selected=0;
    sprintf(menu3[0].text,"unity");
    sprintf(menu3[0].tag_text,"unity");
    
    menu3[1].flash=0;
    menu3[1].group=0;
    menu3[1].hide=0;
    menu3[1].selected=0;
    sprintf(menu3[1].text,"gnome-shell");
    sprintf(menu3[1].tag_text,"gnome-shell");
    
    menu3[2].flash=0;
    menu3[2].group=0;
    menu3[2].hide=0;
    menu3[2].selected=0;
    sprintf(menu3[2].text,"kde");
    sprintf(menu3[2].tag_text,"startkde");
    
    menu3[3].flash=0;
    menu3[3].group=0;
    menu3[3].hide=0;
    menu3[3].selected=0;
    sprintf(menu3[3].text,"xfce4");
    sprintf(menu3[3].tag_text,"startxfce4");
    
    menu3[4].flash=0;
    menu3[4].group=0;
    menu3[4].hide=0;
    menu3[4].selected=0;
    sprintf(menu3[4].text,"lxde");
    sprintf(menu3[4].tag_text,"startlxde");
    
    menu3[5].flash=0;
    menu3[5].group=0;
    menu3[5].hide=0;
    menu3[5].selected=0;
    sprintf(menu3[5].text,"e17");
    sprintf(menu3[5].tag_text,"enlightenment_start");
    
    menu3[6].flash=0;
    menu3[6].group=0;
    menu3[6].hide=0;
    menu3[6].selected=0;
    sprintf(menu3[6].text,"icon-de");
    sprintf(menu3[6].tag_text,"icon-de");

    menu2[1].flash=0;
    menu2[1].group=1;
    menu2[1].hide=0;
    menu2[1].selected=0;
    sprintf(menu2[1].text," box 类 ：");
    
    menu3[10].flash=0;
    menu3[10].group=1;
    menu3[10].hide=0;
    menu3[10].selected=0;
    sprintf(menu3[10].text,"fluxbox");
    sprintf(menu3[10].tag_text,"startfluxbox");
    
    menu3[11].flash=0;
    menu3[11].group=1;
    menu3[11].hide=0;
    menu3[11].selected=0;
    sprintf(menu3[11].text,"blackbox");
    sprintf(menu3[11].tag_text,"blackbox");
    
    menu3[12].flash=0;
    menu3[12].group=1;
    menu3[12].hide=0;
    menu3[12].selected=0;
    sprintf(menu3[12].text,"Openbox");
    sprintf(menu3[12].tag_text,"openbox");
    
    menu3[13].flash=0;
    menu3[13].group=1;
    menu3[13].hide=0;
    menu3[13].selected=0;
    sprintf(menu3[13].text,"Sapphire");
    sprintf(menu3[13].tag_text,"sapphire");

    menu2[2].flash=0;
    menu2[2].group=2;
    menu2[2].hide=0;
    menu2[2].selected=0;
    sprintf(menu2[2].text," 知名/常见 WM：");
    
    menu3[20].flash=0;
    menu3[20].group=2;
    menu3[20].hide=0;
    menu3[20].selected=0;
    sprintf(menu3[20].text,"fvwm");
    sprintf(menu3[20].tag_text,"fvwm");
    
    menu3[21].flash=0;
    menu3[21].group=2;
    menu3[21].hide=0;
    menu3[21].selected=0;
    sprintf(menu3[21].text,"compiz");
    sprintf(menu3[21].tag_text,"compiz");
    
    menu3[22].flash=0;
    menu3[22].group=2;
    menu3[22].hide=0;
    menu3[22].selected=0;
    sprintf(menu3[22].text,"sawfish");
    sprintf(menu3[22].tag_text,"sawfish");
    
    menu3[23].flash=0;
    menu3[23].group=2;
    menu3[23].hide=0;
    menu3[23].selected=0;
    sprintf(menu3[23].text,"pekwm");
    sprintf(menu3[23].tag_text,"pekwm");
    
    menu3[24].flash=0;
    menu3[24].group=2;
    menu3[24].hide=0;
    menu3[24].selected=0;
    sprintf(menu3[24].text,"Jwm");
    sprintf(menu3[24].tag_text,"jwm");
    
    menu3[25].flash=0;
    menu3[25].group=2;
    menu3[25].hide=0;
    menu3[25].selected=0;
    sprintf(menu3[25].text,"Icewm");
    sprintf(menu3[25].tag_text,"icewm");
    
    menu3[26].flash=0;
    menu3[26].group=2;
    menu3[26].hide=0;
    menu3[26].selected=0;
    sprintf(menu3[26].text,"oroborus");
    sprintf(menu3[26].tag_text,"oroborus");
    
    menu3[27].flash=0;
    menu3[27].group=2;
    menu3[27].hide=0;
    menu3[27].selected=0;
    sprintf(menu3[27].text,"Flwm");
    sprintf(menu3[27].tag_text,"flwm");

    menu2[3].flash=0;
    menu2[3].group=3;
    menu2[3].hide=0;
    menu2[3].selected=0;
    sprintf(menu2[3].text,"Wmaker类：");
    
    menu3[30].flash=0;
    menu3[30].group=3;
    menu3[30].hide=0;
    menu3[30].selected=0;
    sprintf(menu3[30].text,"Wmaker");
    sprintf(menu3[30].tag_text,"wmaker");
    
    menu3[31].flash=0;
    menu3[31].group=3;
    menu3[31].hide=0;
    menu3[31].selected=0;
    sprintf(menu3[31].text,"AfterStep");
    sprintf(menu3[31].tag_text,"afterStep");

    menu2[4].flash=0;
    menu2[4].group=4;
    menu2[4].hide=0;
    menu2[4].selected=0;
    sprintf(menu2[4].text,"虚拟视窗类：");
    
    menu3[40].flash=0;
    menu3[40].group=4;
    menu3[40].hide=0;
    menu3[40].selected=0;
    sprintf(menu3[40].text,"fvwm");
    sprintf(menu3[40].tag_text,"fvwm");
    
    menu3[41].flash=0;
    menu3[41].group=4;
    menu3[41].hide=0;
    menu3[41].selected=0;
    sprintf(menu3[41].text,"olvwm");
    sprintf(menu3[41].tag_text,"olvwm");
    
    menu3[42].flash=0;
    menu3[42].group=4;
    menu3[42].hide=0;
    menu3[42].selected=0;
    sprintf(menu3[42].text,"VTWM");
    sprintf(menu3[42].tag_text,"vtwm");
    
    menu2[5].flash=0;
    menu2[5].group=5;
    menu2[5].hide=0;
    menu2[5].selected=0;
    sprintf(menu2[5].text," 平铺 类：");
    
    menu3[50].flash=0;
    menu3[50].group=5;
    menu3[50].hide=0;
    menu3[50].selected=0;
    sprintf(menu3[50].text,"ratpoison");
    sprintf(menu3[50].tag_text,"ratpoison");
    
    menu3[51].flash=0;
    menu3[51].group=5;
    menu3[51].hide=0;
    menu3[51].selected=0;
    sprintf(menu3[51].text,"StumpWM");
    sprintf(menu3[51].tag_text,"stumpwm");
    
    menu3[52].flash=0;
    menu3[52].group=5;
    menu3[52].hide=0;
    menu3[52].selected=0;
    sprintf(menu3[52].text,"awesome");
    sprintf(menu3[52].tag_text,"awesome");
    
    menu3[53].flash=0;
    menu3[53].group=5;
    menu3[53].hide=0;
    menu3[53].selected=0;
    sprintf(menu3[53].text,"i3");
    sprintf(menu3[53].tag_text,"i3");
    
    menu3[54].flash=0;
    menu3[54].group=5;
    menu3[54].hide=0;
    menu3[54].selected=0;
    sprintf(menu3[54].text,"dwm");
    sprintf(menu3[54].tag_text,"dwm");
    
    menu3[55].flash=0;
    menu3[55].group=5;
    menu3[55].hide=0;
    menu3[55].selected=0;
    sprintf(menu3[55].text,"wmii");
    sprintf(menu3[55].tag_text,"wmii");
    
    menu3[56].flash=0;
    menu3[56].group=5;
    menu3[56].hide=0;
    menu3[56].selected=0;
    sprintf(menu3[56].text,"Bluetile");
    sprintf(menu3[56].tag_text,"bluetile");

    menu2[6].flash=0;
    menu2[6].group=6;
    menu2[6].hide=0;
    menu2[6].selected=0;
    sprintf(menu2[6].text," 微型 WM：");
    
    menu3[60].flash=0;
    menu3[60].group=6;
    menu3[60].hide=0;
    menu3[60].selected=0;
    sprintf(menu3[60].text,"ctwm");
    sprintf(menu3[60].tag_text,"ctwm");
    
    menu3[61].flash=0;
    menu3[61].group=6;
    menu3[61].hide=0;
    menu3[61].selected=0;
    sprintf(menu3[61].text,"LWM");
    sprintf(menu3[61].tag_text,"lwm");
    
    menu3[62].flash=0;
    menu3[62].group=6;
    menu3[62].hide=0;
    menu3[62].selected=0;
    sprintf(menu3[62].text,"MIWM");
    sprintf(menu3[62].tag_text,"miwm");
    
    menu3[63].flash=0;
    menu3[63].group=6;
    menu3[63].hide=0;
    menu3[63].selected=0;
    sprintf(menu3[63].text,"TinyWM");
    sprintf(menu3[63].tag_text,"tinywm");
    
    menu3[64].flash=0;
    menu3[64].group=6;
    menu3[64].hide=0;
    menu3[64].selected=0;
    sprintf(menu3[64].text,"WindowLab");
    sprintf(menu3[64].tag_text,"WindowLab");
    
    menu3[65].flash=0;
    menu3[65].group=6;
    menu3[65].hide=0;
    menu3[65].selected=0;
    sprintf(menu3[65].text,"wm2");
    sprintf(menu3[65].tag_text,"wm2");
    
    menu3[66].flash=0;
    menu3[66].group=6;
    menu3[66].hide=0;
    menu3[66].selected=0;
    sprintf(menu3[66].text,"evilwm");
    sprintf(menu3[66].tag_text,"evilwm");

    menu2[7].flash=0;
    menu2[7].group=7;
    menu2[7].hide=0;
    menu2[7].selected=0;
    sprintf(menu2[7].text," 其他老旧WM：");
    
    menu3[70].flash=0;
    menu3[70].group=7;
    menu3[70].hide=0;
    menu3[70].selected=0;
    sprintf(menu3[70].text,"9wm");
    sprintf(menu3[70].tag_text,"9wm");
    
    menu3[71].flash=0;
    menu3[71].group=7;
    menu3[71].hide=0;
    menu3[71].selected=0;
    sprintf(menu3[71].text,"aewm");
    sprintf(menu3[71].tag_text,"aewm");
    
    menu3[72].flash=0;
    menu3[72].group=7;
    menu3[72].hide=0;
    menu3[72].selected=0;
    sprintf(menu3[72].text,"aewm++");
    sprintf(menu3[72].tag_text,"aewm++");
    
    menu3[73].flash=0;
    menu3[73].group=7;
    menu3[73].hide=0;
    menu3[73].selected=0;
    sprintf(menu3[73].text,"olwm");
    sprintf(menu3[73].tag_text,"olwm");
    
    menu3[74].flash=0;
    menu3[74].group=7;
    menu3[74].hide=0;
    menu3[74].selected=0;
    sprintf(menu3[74].text,"w9wm");
    sprintf(menu3[74].tag_text,"w9wm");
    
    menu3[75].flash=0;
    menu3[75].group=7;
    menu3[75].hide=0;
    menu3[75].selected=0;
    sprintf(menu3[75].text,"Scrotwm");
    sprintf(menu3[75].tag_text,"scrotwm");
    
    menu3[76].flash=0;
    menu3[76].group=7;
    menu3[76].hide=0;
    menu3[76].selected=0;
    sprintf(menu3[76].text,"tritium");
    sprintf(menu3[76].tag_text,"tritium");
    
    menu3[77].flash=0;
    menu3[77].group=7;
    menu3[77].hide=0;
    menu3[77].selected=0;
    sprintf(menu3[77].text,"amiwm");
    sprintf(menu3[77].tag_text,"amiwm");
    
    menu2[8].flash=0;
    menu2[8].group=8;
    menu2[8].hide=0;
    menu2[8].selected=0;
    sprintf(menu2[8].text," DE中的WM：");
    
    menu3[80].flash=0;
    menu3[80].group=8;
    menu3[80].hide=0;
    menu3[80].selected=0;
    sprintf(menu3[80].text,"compiz");
    sprintf(menu3[80].tag_text,"compiz");
    
    menu3[81].flash=0;
    menu3[81].group=8;
    menu3[81].hide=0;
    menu3[81].selected=0;
    sprintf(menu3[81].text,"mutter");
    sprintf(menu3[81].tag_text,"mutter");
    
    menu3[82].flash=0;
    menu3[82].group=8;
    menu3[82].hide=0;
    menu3[82].selected=0;
    sprintf(menu3[82].text,"metacity");
    sprintf(menu3[82].tag_text,"metacity");
    
    menu3[83].flash=0;
    menu3[83].group=8;
    menu3[83].hide=0;
    menu3[83].selected=0;
    sprintf(menu3[83].text,"kwin");
    sprintf(menu3[83].tag_text,"kwin");
    
    menu3[84].flash=0;
    menu3[84].group=8;
    menu3[84].hide=0;
    menu3[84].selected=0;
    sprintf(menu3[84].text,"xfwm4");
    sprintf(menu3[84].tag_text,"xfwm4");
    menu2[10].flash=0;
    menu2[10].group=10;
    menu2[10].hide=0;
    menu2[10].selected=0;
    sprintf(menu2[10].text,"操 作 员：");

    setpwent();   
    struct passwd *pw = getpwent();
    i=100;
    while ((pw) and (i<150))
    {
        if ((pw->pw_uid>=1000) and (pw->pw_uid<65534))
        {
            menu3[i].flash=0;
            menu3[i].group=10;
            menu3[i].hide=0;
            menu3[i].selected=0;
            sprintf(menu3[i].text,"%s",pw->pw_name);
            sprintf(menu3[i].tag_text,"%s",pw->pw_passwd);
            menu3[i].tag_int=pw->pw_uid;
            i=i+1;
        }
        pw = getpwent();
    }
    endpwent();
	menu2[9].flash=0;
	menu2[9].group=9;
	menu2[9].hide=0;
	menu2[9].selected=0;
	sprintf(menu2[9].text," 自定义WM：");
	char usr[1024],wm[1024];
	menu3[90].flash=0;
	menu3[90].group=9;
	menu3[90].hide=0;
	menu3[90].selected=0;
	sprintf(menu3[90].text,"%s",cfg->getOption("our_wm1").c_str());
	sprintf(menu3[90].tag_text,"%s",cfg->getOption("our_wm1").c_str());

	menu3[91].flash=0;
	menu3[91].group=9;
	menu3[91].hide=0;
	menu3[91].selected=0;
	sprintf(menu3[91].text,"%s",cfg->getOption("our_wm2").c_str());
	sprintf(menu3[91].tag_text,"%s",cfg->getOption("our_wm2").c_str());

	menu3[92].flash=0;
	menu3[92].group=9;
	menu3[92].hide=0;
	menu3[92].selected=0;
	sprintf(menu3[92].text,"%s",cfg->getOption("our_wm3").c_str());
	sprintf(menu3[92].tag_text,"%s",cfg->getOption("our_wm3").c_str());

	sprintf(wm,"%s",cfg->getOption("default_wm").c_str());
	for (n=0;n<99;n++)
	{
		if (strcmp(wm,menu3[n].text) == 0)
		{
			menu3[n].selected=1;
			break;
		}
	}
	sprintf(usr,"%s",cfg->getOption("default_usr").c_str());
	for (n=100;n<150;n++)
	{
		if (strcmp(usr,menu3[n].text) == 0)
		{
			menu3[n].selected=1;
			break;
		}
	}
	sprintf(menu1.text,"请分别选择以下选项，然后按“登录”——上次的选择:WM--%s,USER--%s",wm,usr);
}

imenu::~imenu() {
    XftColorFree (Dpy, DefaultVisual(Dpy, Scr), DefaultColormap(Dpy, Scr), &msgcolor);
    XftColorFree (Dpy, DefaultVisual(Dpy, Scr), DefaultColormap(Dpy, Scr), &msgshadowcolor);
    XftFontClose(Dpy, msgfont);
    hide_button();//menu
}

char * imenu::getSession() {
    int i;
    for (i=0;i<100;i++)
    {
        if (menu3[i].selected==1)
            break;
    }
    return menu3[i].text;
}

const char * imenu::GetName(void) const{
    int i;
    for (i=100;i<150;i++)
    {
        if (menu3[i].selected==1)
            break;
    }
    return menu3[i].text;
};
const char * imenu::GetPasswd(void) const{
    return input.tag_text;
};

void imenu::Message(const string& text) {
    string cfgX, cfgY;
    XGlyphInfo extents;
    XftDraw *draw = XftDrawCreate(Dpy, Root,
                                  DefaultVisual(Dpy, Scr), DefaultColormap(Dpy, Scr));
    XftTextExtents8(Dpy, msgfont, reinterpret_cast<const XftChar8*>(text.c_str()),
                    text.length(), &extents);
    cfgX = cfg->getOption("msg_x");
    cfgY = cfg->getOption("msg_y");
    int shadowXOffset =
        Cfg::string2int(cfg->getOption("msg_shadow_xoffset").c_str());
    int shadowYOffset =
        Cfg::string2int(cfg->getOption("msg_shadow_yoffset").c_str());

    int msg_x = Cfg::absolutepos(cfgX, XWidthOfScreen(ScreenOfDisplay(Dpy, Scr)), extents.width);
    int msg_y = Cfg::absolutepos(cfgY, XHeightOfScreen(ScreenOfDisplay(Dpy, Scr)), extents.height);

    icondmDrawString8 (draw, &msgcolor, msgfont, msg_x, msg_y,
                     text,
                     &msgshadowcolor,
                     shadowXOffset, shadowYOffset);
    XFlush(Dpy);
    XftDrawDestroy(draw);
}


void imenu::icondmDrawString8(XftDraw *d, XftColor *color, XftFont *font,
                            int x, int y, const string& str,
                            XftColor* shadowColor,
                            int xOffset, int yOffset)
{
    if (xOffset && yOffset) {
        XftDrawString8(d, shadowColor, font, x+xOffset, y+yOffset,
                       reinterpret_cast<const FcChar8*>(str.c_str()), str.length());
    }
    XftDrawString8(d, color, font, x, y, reinterpret_cast<const FcChar8*>(str.c_str()), str.length());
}
