/* icondm - Icon DE Display Manager
*/

#ifndef _NUMLOCK_H_
#define _NUMLOCK_H_

#include <X11/Xlib.h>
#include <X11/XKBlib.h>
#include <X11/keysym.h>

class NumLock {

public:
    NumLock();
    static void setOn();
    static void setOff();

private:
    static int xkb_init(Display* dpy);
    static unsigned int xkb_mask_modifier( XkbDescPtr xkb, const char *name );
    static unsigned int xkb_numlock_mask(Display* dpy);
};

#endif
